"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Copyright (c) 2018, salesforce.com, inc.
 * All rights reserved.
 * SPDX-License-Identifier: MIT
 * For full license text, see the LICENSE file in the repo root or https://opensource.org/licenses/MIT
 */
var plugin_transform_template_literals_1 = __importDefault(require("@babel/plugin-transform-template-literals"));
var plugin_transform_literals_1 = __importDefault(require("@babel/plugin-transform-literals"));
var plugin_transform_function_name_1 = __importDefault(require("@babel/plugin-transform-function-name"));
var plugin_transform_arrow_functions_1 = __importDefault(require("@babel/plugin-transform-arrow-functions"));
var plugin_transform_block_scoped_functions_1 = __importDefault(require("@babel/plugin-transform-block-scoped-functions"));
var plugin_transform_classes_1 = __importDefault(require("@babel/plugin-transform-classes"));
var plugin_transform_object_super_1 = __importDefault(require("@babel/plugin-transform-object-super"));
var plugin_transform_shorthand_properties_1 = __importDefault(require("@babel/plugin-transform-shorthand-properties"));
var plugin_transform_duplicate_keys_1 = __importDefault(require("@babel/plugin-transform-duplicate-keys"));
var plugin_transform_computed_properties_1 = __importDefault(require("@babel/plugin-transform-computed-properties"));
var plugin_transform_for_of_1 = __importDefault(require("@babel/plugin-transform-for-of"));
var plugin_transform_sticky_regex_1 = __importDefault(require("@babel/plugin-transform-sticky-regex"));
var plugin_transform_unicode_regex_1 = __importDefault(require("@babel/plugin-transform-unicode-regex"));
var plugin_transform_spread_1 = __importDefault(require("@babel/plugin-transform-spread"));
var plugin_transform_parameters_1 = __importDefault(require("@babel/plugin-transform-parameters"));
var plugin_transform_destructuring_1 = __importDefault(require("@babel/plugin-transform-destructuring"));
var plugin_transform_block_scoping_1 = __importDefault(require("@babel/plugin-transform-block-scoping"));
var plugin_transform_typeof_symbol_1 = __importDefault(require("@babel/plugin-transform-typeof-symbol"));
var plugin_transform_modules_commonjs_1 = __importDefault(require("@babel/plugin-transform-modules-commonjs"));
var plugin_transform_modules_systemjs_1 = __importDefault(require("@babel/plugin-transform-modules-systemjs"));
var plugin_transform_modules_amd_1 = __importDefault(require("@babel/plugin-transform-modules-amd"));
var plugin_transform_modules_umd_1 = __importDefault(require("@babel/plugin-transform-modules-umd"));
var plugin_transform_instanceof_1 = __importDefault(require("@babel/plugin-transform-instanceof"));
var plugin_transform_regenerator_1 = __importDefault(require("@babel/plugin-transform-regenerator"));
// ES2016 + ES2017 support
var plugin_transform_async_to_generator_1 = __importDefault(require("@babel/plugin-transform-async-to-generator"));
var plugin_transform_exponentiation_operator_1 = __importDefault(require("@babel/plugin-transform-exponentiation-operator"));
var plugin_proposal_object_rest_spread_1 = __importDefault(require("@babel/plugin-proposal-object-rest-spread"));
var plugin_proposal_class_properties_1 = __importDefault(require("@babel/plugin-proposal-class-properties"));
// Polyfills & helpers && COMPAT
var plugin_transform_runtime_1 = __importDefault(require("@babel/plugin-transform-runtime"));
var babel_plugin_transform_proxy_compat_1 = __importDefault(require("babel-plugin-transform-proxy-compat"));
function compatPreset(ctx, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.loose, loose = _c === void 0 ? false : _c, _d = _b.modules, modules = _d === void 0 ? 'es' : _d, _e = _b.spec, spec = _e === void 0 ? false : _e, _f = _b.disableProxyTransform, disableProxyTransform = _f === void 0 ? false : _f, _g = _b.onlyProxyTransform, onlyProxyTransform = _g === void 0 ? false : _g;
    var plugins = [];
    var moduleTypes = ['es', 'commonjs', 'cjs', 'amd', 'umd', 'systemjs'];
    var optsLoose = { loose: loose };
    if (typeof loose !== 'boolean') {
        throw new Error('Preset es2015 "loose" option must be a boolean.');
    }
    if (typeof spec !== 'boolean') {
        throw new Error('Preset es2015 "spe" option must be a boolean.');
    }
    if (moduleTypes.indexOf(modules) === -1) {
        throw new Error('Preset compat "modules" option must be "false" to indicate no modules\n' +
            'or a module type which be be one of: "es", "commonjs" (default), "amd", "umd", "systemjs"');
    }
    var compatPlugins = [
        [plugin_proposal_class_properties_1.default, { spec: spec }],
        [plugin_proposal_object_rest_spread_1.default, { useBuiltIns: true }],
        plugin_transform_exponentiation_operator_1.default,
        [plugin_transform_template_literals_1.default, { loose: loose, spec: spec }],
        plugin_transform_literals_1.default,
        plugin_transform_function_name_1.default,
        [plugin_transform_arrow_functions_1.default, { spec: spec }],
        plugin_transform_block_scoped_functions_1.default,
        [plugin_transform_classes_1.default, optsLoose],
        plugin_transform_object_super_1.default,
        plugin_transform_shorthand_properties_1.default,
        plugin_transform_duplicate_keys_1.default,
        [plugin_transform_computed_properties_1.default, optsLoose],
        [plugin_transform_for_of_1.default, optsLoose],
        plugin_transform_sticky_regex_1.default,
        plugin_transform_unicode_regex_1.default,
        [plugin_transform_spread_1.default, optsLoose],
        [plugin_transform_parameters_1.default, optsLoose],
        [plugin_transform_destructuring_1.default, optsLoose],
        plugin_transform_block_scoping_1.default,
        plugin_transform_typeof_symbol_1.default,
        plugin_transform_instanceof_1.default,
        (modules === 'commonjs' || modules === 'cjs') && [plugin_transform_modules_commonjs_1.default, optsLoose],
        modules === 'systemjs' && [plugin_transform_modules_systemjs_1.default, optsLoose],
        modules === 'amd' && [plugin_transform_modules_amd_1.default, optsLoose],
        modules === 'umd' && [plugin_transform_modules_umd_1.default, optsLoose],
        plugin_transform_async_to_generator_1.default,
        [plugin_transform_regenerator_1.default, { async: true, asyncGenerators: true, generators: true }],
        [plugin_transform_runtime_1.default, { helpers: true }]
    ].filter(Boolean);
    var proxyPlugins = [babel_plugin_transform_proxy_compat_1.default];
    if (!onlyProxyTransform) {
        plugins.push.apply(plugins, compatPlugins);
    }
    if (!disableProxyTransform) {
        plugins.push.apply(plugins, proxyPlugins);
    }
    return {
        plugins: plugins,
        parserOpts: { plugins: ['asyncGenerators'] }
    };
}
exports.default = compatPreset;
//# sourceMappingURL=module.js.map